<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :isValidate="true" :offsetArrow="20" :spanTitle="3" title="Menú Principal" v-on:clickEvent="viewListReview" style="margin-bottom:2.5rem"></ReturnButton>
      <el-row :gutter="20">
        <!-- FILTROS DE BUSQUEDA --> 
        <el-col :span="18" class="text-end">
          <app-select v-model="filterSelect" :filterArray="allFilters"></app-select>
        </el-col>
        <el-col :span="6">
          <app-search-filter v-model="textSearch"></app-search-filter>
        </el-col>  
      </el-row>
    </header>

    <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 6rem">
      <Title :Title="'REVISION DE ' + matType + ' - ' +typeMaterialR.toUpperCase()"> </Title>
    </div>

    <!-- Leyenda -->
    <div style="margin:3rem 6rem">
      <DescriptionStateOrders TextSquareGray="Sin Revisar" TextSquareGreen="Aprobado y Al aire" TextSquareBlue="Aprobado, pero no emitido" :TextSquareRed="''" TextSquareOrange="Aprobado y Emitido" :colBoxes="6"> </DescriptionStateOrders>
    </div>

    <el-main style="margin:3rem 5rem">
      <el-row>
        <el-col 
          v-for="(material, index) in materials.slice(0,30)"
          :key="index"
          :span="18" :offset="3"
          style="margin-bottom: 4rem">
          <app-card-review
            :itemPrincipal="material" 
            :rutaImg="getImgUrl(image)" :shadowBox="colorShadow(material.typeOfContent)" :imgStyle="'icon-card'" :showRate="false"
            :detailsData="details(material)"
            :detailsData2="detailsSecond(material)"
            :btnGroup="{
              0:{validationBtnShow: material.reviewStatus === 'withoutChecking', btnClass: 'border-grey-darken text-dark-gray-2', btnTextAction: 'SIN REVISAR', editVal: 'selectedMaterial', newVal: reviewReport(material.numChapters)},  
              1:{validationBtnShow: material.reviewStatus === 'approved2', btnClass: 'border-blue text-blue', btnTextAction: 'NO EMITIDO', editVal: 'selectedMaterial', newVal:  report(material.numChapters)},
              2:{validationBtnShow: material.reviewStatus === 'live',btnClass: 'border-green text-green', btnTextAction: 'AL AIRE', editVal: 'selectedMaterial', newVal:  report(material.numChapters)},
              3:{validationBtnShow: material.reviewStatus === 'transmitted', btnClass: 'border-orange text-orange', btnTextAction: 'EMITIDO', editVal: 'selectedMaterial', newVal:  report(material.numChapters)},
              4: {validationBtnShow: material.reviewStatus === 'incompleteStyle', btnClass: 'b-purple t-purple', btnTextAction: 'INCOMPLETO', editVal: 'selectedMaterial', newVal: report(material.numChapters)}
            }"/>
        </el-col>
      </el-row>
    </el-main>
  </div>
</template>

<script>
import router from 'vue-router'
import SearchFilter from '@/components/searchFilter.vue'
import Select from '@/components/AppSelect.vue'
import ReturnButton from '@/components/ReturnButton.vue'
import { modifyText } from '@/utils/modifyText.js'
import CardReview from '@/components/cardReview'
import Title from '@/components/Title.vue'
import DescriptionStateOrders from '@/components/DescriptionStateOrders.vue'
import { HTTP } from '@/main.js'
import cooking from '@/assets/images/r_fusion.svg'

export default {
  components: {
    ReturnButton,
    'app-search-filter': SearchFilter,
    'app-select': Select,
    'app-card-review': CardReview,
    Title,
    DescriptionStateOrders,
  },
  data () {
    return {
      mType: '',
      canned: false,
      returnButtonModal: false,
      filterSelect: '',
      textSearch: '',
      allFilters: [
        {value: 'providerCode', label: 'Código de Proveedor'},
        {value: 'codMaterial', label: 'Código de Material'}
      ],
      typeMaterialR: localStorage.getItem("typeMaterialR"),
      matType: localStorage.getItem('classification'),
      materials: [],
      image: '',
      listGenders: []
    }
  },
  created () {
    const type = this.$route.params.name
    this.image = this.asignedImage(type)
    this.getMaterials(type)
  },
  methods: {
    verificateGender(val) {
      let genero = val && val.length > 0 ? val : []
      let nombres = []
      genero.forEach((el) => {
        this.listGenders.filter((e) => {
          if (el == e.code) {
            nombres.push(e.name)
          }
        })
      })
      return nombres
    },
    getMaterials(value) {
      let dataType = 'materials'
      let route
      if(this.matType == 'FUSIÓN GOURMET') {
        route = 'materials/materialType/Fusión Gourmet/typeOfContent/'+value+'/canned/false'
      } else if(this.matType == 'PRODUCCIÓN NACIONAL') {
        route = '/materials/materialType/Producción Nacional/typeOfContent/'+value+'/canned/false'
      }else{
        route = 'materials/materialType/'+value+'/canned/false'
      }
      HTTP.get(route)
        .then(res => {
          this.materials = this.orderDataByGeminisCode(res.data.materials)
        })
        .catch(err => {
          console.log(err);
        });
    },
    viewListReview () {
      if(this.matType == 'FUSIÓN GOURMET' || this.matType == 'Fusión Gourmet') {
        this.$router.push({name: 'tiposFusionRevision'})
      }
      else {
        this.$router.push({name: 'produccionNacional'})
      }
    },
    getImgUrl(pic) {
      return require('@/assets/images/'+pic)
    },
    asignedImage(type) {
      let transformType = type.toLowerCase()
      let image
      switch(transformType) {
        case 'cocina':
          image = 'r_fusion.svg'
          break;
        case 'largometrajes':
          image = 'largometraje.svg'
          break;
        case 'novelas':
          image = 'novela.svg'
          break;
        case 'series':
          image = 'serie.svg'
          break;
        case 'miniseries':
          image = 'miniserie.svg'
          break;
        case 'dibujos':
          image = 'dibujo.svg'
          break;
        case 'especial':
          image = 'especiales.svg'
          break;
        case 'deportes':
          image = 'icono-deportivo.svg'
          break;
        case 'programas especiales':
          image = 'icono-progespeciales.svg'
          break;
        default:
          image = `icono-${transformType}.svg`
          break;
      }
      return image
    },
    details(value) {
      let object = {}
      if(value.numChapters.length > 0) {
        object = {
          0:{subtitle: 'Código de Material', content: value.codMaterial},
          1:{subtitle: 'Temporarada', content: (value.numChapters.map(i => i.season)).join(' - ')},
          2:{subtitle: 'Proveedor', content: value.providerName},
        }
      } else {
        object = {
          0:{subtitle: 'Código de Material', content: value.codMaterial},
          1:{subtitle: 'Proveedor', content: value.providerName},
          2:{subtitle: 'Género', content: this.verificateGender(value.genre).length > 0 ? this.verificateGender(value.genre).toString().replace(/,/gi, ', ') : `Sin género asignado.` },
        }
      }
      return object
    },
    detailsSecond(value) {
      let object
      if(value.numChapters.length > 0) {
        object = {
          0:{subtitle: 'Género', content: this.verificateGender(value.genre).length > 0 ? this.verificateGender(value.genre).toString().replace(/,/gi, ', ') : `Sin género asignado.`},
          1:{subtitle: 'Clasificación', content: value.classification}
        }
      } else {
          object = {
          0:{subtitle: 'Clasificación', content: value.classification},
          1:{subtitle: 'Etiquetas', content: (value.reviewObj)?Array(Object(value.reviewObj).dynamicTags).join(', '):''}
        }
      }
      return object
    },
    report(value) {
      if(value.length > 0) {
        return 'reportFusionGourmet'
      } else {
        return 'reporteNacional'
      }
    },
    reviewReport(value) {
      if(value.length > 0) {
        return 'revFusionGourmet'
      } else {
        return 'revisionNacional'
      }
    },
    orderDataByGeminisCode (array) {
      array.sort(function (a, b) {
        if ( Number(a.geminisCode) < Number(b.geminisCode) ) {
          return 1;
        }
        if ( Number(a.geminisCode) > Number(b.geminisCode )) {
          return -1;
        }
        return 0;
      });
      return array
    },
    colorShadow(value) {
      switch(value) {
        case 'Político':
          return 'darkblue-shadow'
        break;
        case 'Entretenimiento':
          return 'pinkCard-shadow'
        break;
        case 'Religioso':
          return 'color-aqua-shadow'
        break;
        case 'Electoral':
          return 'darkRed-shadow'
        break;
        case 'Largometrajes':
          return 'blue-shadow'
        break;
        case 'Novelas':
          return 'pink-shadow'
        break;
        case 'Series':
          return 'skyblue-shadow'
        break;
        case 'Femenino':
          return 'skyblue-shadow'
        break;
        case 'Infantil':
          return 'color-card-child-shadow'
        break;
        case 'Magazine':
          return 'color-green-shadow'
        break;
        case 'Entrevista':
          return 'color-magenta-shadow'
        break;
        case 'Entrevista':
          return 'color-magenta-shadow'
        break;
        case 'Miniseries':
          return 'color-purple-shadow'
        break;
        case 'Dibujos':
          return 'color-yellow-shadow'
        break;
        case 'Especial':
          return 'color-green-shadow'
        break;
        case 'Periodístico':
          return 'darkmagenta-shadow'
        break;
        case 'Cómico':
          return 'lightpurple-shadow'
        break; 
        case 'Talkshow':
          return 'darkpink-shadow'
        break;
        case 'Microprograma':
          return 'grey-shadow'
        break;
        case 'Deportivo':
          return 'lightblue-shadow'
        break;
        case 'Cocina':
          return 'gold-shadow'
        break;
        case 'Programas Especiales':
          return 'greenApple-shadow'
        break;
        default:
          return 'grey-shadow'
        break;
      }
    }
  },
  async beforeMount() {
    const {data}=  await HTTP.get(`materials/list/genres`)
    this.listGenders = data.listGenders
  }
}
</script>

<style>
.grey-shadow{
  box-shadow: 5px 5px 5px 0px rgba(0, 0, 0, 0.15) !important;
}
.icon-card{
  width: 90%;
}
</style>
